import { StateCreator, StoreMutatorIdentifier } from '../vanilla';
declare type Write<T, U> = Omit<T, keyof U> & U;
declare type ReduxState<A> = {
    dispatch: StoreRedux<A>['dispatch'];
};
declare type StoreRedux<A> = {
    dispatch: (a: A) => A;
    dispatchFromDevtools: true;
};
declare type WithRedux<S, A> = Write<S, StoreRedux<A>>;
declare type Redux = <T, A, Cms extends [StoreMutatorIdentifier, unknown][] = []>(reducer: (state: T, action: A) => T, initialState: T) => StateCreator<Write<T, ReduxState<A>>, Cms, [['zustand/redux', A]]>;
declare module '../vanilla' {
    interface StoreMutators<S, A> {
        'zustand/redux': WithRedux<S, A>;
    }
}
export declare const redux: Redux;
export {};
